!	T3X runtime class: dynamic memory management
!	Copyright (C) 1997,1998,1999 Nils M Holm. All rights reserved.
!	See the file LICENSE for conditions of use.

module memory();


public class memory(t3x)

 object	t[t3x];

 const	FREEBIT = 32768;

 var	Arena;
 var	Freezone;
 var	BytesPerWord;


 public init(pool, size) do
	BytesPerWord := t.bpw();
	Arena := pool;
	size := size/BytesPerWord;
	Arena[0] := size-1 | FREEBIT;
	Arena[size-1] := 0;
	Freezone := 0;
 end


 public walk(blk, sizep, statp) do
	ie (blk)
		blk := @blk[(blk[%1] & ~FREEBIT) - 1];
	else
		blk := Arena;
	if (sizep) sizep[0] := ((blk[0] & ~FREEBIT) - 1) * BytesPerWord;
	if (statp) statp[0] := (blk[0] & FREEBIT) \= 0;
	if (\blk[0]) return 0;
	return @blk[1];
 end


 public alloc(size) do
	var	ap, k, i;

	size := (size+BytesPerWord-1)/BytesPerWord+ 1;
	while (1) do
		ap := Freezone;
		while (Arena[ap]) do
			k := Arena[ap];
			if (k & FREEBIT) do
				k := k & ~FREEBIT;
				ie (size = k) do
					Freezone := ap;
					Arena[ap] := k;
					return @Arena[ap+1];
				end
				else if (size < k) do
					Freezone := ap;
					Arena[ap] := size;
					Arena[ap+size] := k-size | FREEBIT;
					return @Arena[ap+1];
				end
			end
			ap := ap + (k & ~FREEBIT);
		end
		if (Freezone = 0) return 0;
		Freezone := 0;
	end
 end


 public free(blk) do
	var	ap, k;
	var	head, tail;
	var	badblk;

	badblk := packed"mem_free(): bad block\r\n";
	if (blk .< Arena \/ blk[%1] & FREEBIT) do
		t.write(2, badblk, 23);
		halt %1;
	end
	blk[%1] := blk[%1] | FREEBIT;
	ap := 0;
	head := %1;
	while (@Arena[ap] .< blk) do
		if (Arena[ap] = 0) do
			t.write(2, badblk, 23);
			halt %1;
		end
		ie (Arena[ap] & FREEBIT) do
			if (head = %1) head := ap;
			if (ap .< Freezone) Freezone := ap;
		end
		else do
			head := %1;
		end
		tail := ap;
		ap := ap + (Arena[ap] & ~FREEBIT);
	end
	while (Arena[ap]) do
		if (\(Arena[ap] & FREEBIT)) leave;
		tail := ap;
		ap := ap + (Arena[ap] & ~FREEBIT);
	end
	tail := tail + (Arena[tail] & ~FREEBIT);
	Arena[head] := tail-head | FREEBIT;
 end

end


do
end

