!	MKR5LIB -- create the T3X-R5 compatibility class
!	Copyright (C) 1999,2000 Nils M Holm. All rights reserved.
!	See the file LICENSE for conditions of use.
!
!	FOR INTERNAL USE ONLY.
!
!	SYNTAX: MKR5LIB >>CLASSFILE

module mkr5lib(t3x, tcode);

object	t[t3x];


! XXX These defintions have to be looked up in the Tcode module R5C.CLS
! XXX -- Fixme! --
const BASE = 100;	! MUST BE GREATER THAN THE GREATEST LABEL IN R5C.CLS
const OFFSET = 5;	! MUSTE BE THE LABEL OF THE FIRST PROC IN R5C.CLS


var	Buffer::1024, Top;


gen0(n) do
	Buffer::Top := n;
	Top := Top+1;
end

gen1(n, m) do
	gen0(n);
	gen0(m);
	gen0(m>>8);
end


gens(s) do var k, i;
	k := 0;
	while (s::k) k := k+1;
	gen0(k);
	gen0(k>>8);
	for (i=0, k) gen0(s::i);
end


do
	var	procs;
	var	i, j, n, a;

	Top := 0;
	procs := [
		[ 2, packed"open"		],
		[ 1, packed"close"		],
		[ 1, packed"erase"		],
		[ 2, packed"select"		],
		[ 2, packed"reads"		],
		[ 1, packed"writes"		],
		[ 0, packed"newline"		],
		[ 1, packed"aton"		],
		[ 2, packed"ntoa"		],
		[ 2, packed"pack"		],
		[ 2, packed"unpack"		],
		[ 3, packed"readpacked"		],
		[ 3, packed"writepacked"	],
		[ 4, packed"reposition"		],
		[ 2, packed"rename"		],
		[ 3, packed"memcopy"		],
		[ 3, packed"memcomp"		]
	];

	n := BASE;
	for (i=0, 17) do
		gen1(tcode.IPUB, n); gens(procs[i][1]);
		a := procs[i][0];
		gen1(tcode.ICLAB, n);
		gen0(tcode.IHDR);
		for (j=0, a) gen1(tcode.ILDL, j-a-1);
		gen0(tcode.ISELF);
		gen1(tcode.ICALL, i+OFFSET);
		gen1(tcode.ICLEAN, a+1);
		gen0(tcode.IPOP);
		gen0(tcode.IEND);
		n := n+1;
	end
	t.write(T3X.SYSOUT, Buffer, Top);
end
