/* The Tcode3 Instruction Set */
#define	ICLAB	0x81	/* L - code label */
#define	IDLAB	0x82	/* L - data label */
#define	IDECL	0x83	/* N - declare */
#define	IDATA	0x84	/* N - data */
#define	ICREF	0x85	/* L - code reference */
#define	IDREF	0x86	/* L - data reference */
#define	ISTR	0x87	/* K S - string */
#define	IPSTR	0x88	/* K S - packed string */
#define	IINIT	0x89	/* 3 N - init module */
#define	IHDR	0x0A	/* - procedure header */
#define	IEND	0x0B	/* - end proc ctx and return */
#define	ICCTX	0x0C	/* - create class context */
#define	IECTX	0x0D	/* - end class context */
#define	IPOP	0x0E	/* - pop to RR */
#define	IDUP	0x0F	/* - duplicate */
#define	ISWAP	0x10	/* - swap */
#define	ISTACK	0x91	/* N - adjust stack */
#define	ICLEAN	0x92	/* N - cleanup stack */
#define	INEG	0x13	/* - negate */
#define	ILNOT	0x14	/* - logical not */
#define	IBNOT	0x15	/* - binary not */
#define	INOP	0x16	/* - null operation */
#define	IINCG	0x97	/* L N - increment global */
#define	IINCI	0x98	/* N M - increment ivar */
#define	IINCL	0x99	/* N M - increment local */
#define	IMUL	0x1A	/* - multiply */
#define	IDIV	0x1B	/* - divide */
#define	IUMUL	0x1C	/* - unsigned multiply */
#define	IUDIV	0x1D	/* - unsigned divide */
#define	IMOD	0x1E	/* - modulo */
#define	IADD	0x1F	/* - add */
#define	ISUB	0x20	/* - subtract */
#define	IBAND	0x21	/* - binary and */
#define	IBOR	0x22	/* - binary or */
#define	IBXOR	0x23	/* - binary xor */
#define	IBSHL	0x24	/* - binary shift left */
#define	IBSHR	0x25	/* - binary shift right */
#define	IEQU	0x26	/* - equal */
#define	INEQU	0x27	/* - not equal */
#define	ILESS	0x28	/* - less */
#define	IGRTR	0x29	/* - greater */
#define	ILTEQ	0x2A	/* - less / equal */
#define	IGTEQ	0x2B	/* - greater / equal */
#define	IULESS	0x2C	/* - unsigned less */
#define	IUGRTR	0x2D	/* - unsigned greater */
#define	IULTEQ	0x2E	/* - unsigned less / equal */
#define	IUGTEQ	0x2F	/* - unsigned greater / equal */
#define	ILDG	0xB0	/* L - load global */
#define	ILDGV	0xB1	/* L - load global vector */
#define	ILDL	0xB2	/* N - load local */
#define	ILDLV	0xB3	/* N - local local vector */
#define	ILDI	0xB4	/* N - load instance */
#define	ILDIV	0xB5	/* N - load instance vector */
#define	ILDLAB	0xB6	/* L - load label */
#define	INUM	0xB7	/* N - load number */
#define	ISELF	0x38	/* - load instance pointer */
#define	IIND	0x39	/* - indirection */
#define	IINDB	0x3A	/* - bytewise indirection */
#define	IDEREF	0x3B	/* - dereference */
#define	IDREFB	0x3C	/* - dereference byte */
#define	ISAVG	0xBD	/* L - save global */
#define	ISAVL	0xBE	/* N - save local */
#define	ISAVI	0xBF	/* N - save instance */
#define	ISTORE	0x40	/* - save indirect */
#define	ISTORB	0x41	/* - save indirect byte */
#define	ICALL	0xC2	/* L - call procedure */
#define	ICALR	0x43	/* - call indirect procedure */
#define	ISYS	0xC4	/* N - execute RTS procedure N */
#define	IBRF	0xC5	/* L - branch on false */
#define	IBRT	0xC6	/* L - branch on true */
#define	INBRF	0xC7	/* L - non-destructive branch on false */
#define	INBRT	0xC8	/* L - non-destructive branch on true */
#define	IJUMP	0xC9	/* L - jump */
#define	IUNEXT	0xCA	/* L - upward next loop */
#define	IDNEXT	0xCB	/* L - downward next loop */
#define	IHALT	0xCC	/* N - halt program */
#define	IPUB	0xCD	/* L K S - public symbol */
#define	IEXT	0xCE	/* L K S - external symbol */
#define	ICALX	0xCF	/* E - call external procedure */
#define	ILINE	0xD0	/* N - debug: line number */
#define	IGSYM	0xD1	/* L K S - debug: global symbol */
#define	ILSYM	0xD2	/* N K S - debug: local symbol */
#define	IISYM	0xD3	/* N K S - debug: instance symbol */
#define	ICKSTK	0x54	/* - debug: check for stack overflow */
#define	IENDOFSET	85
