module tcode();

public class tcode()
	! The Tcode3 Instruction Set
	public const	ICLAB	= 0x81;	! L - code label
	public const	IDLAB	= 0x82;	! L - data label
	public const	IDECL	= 0x83;	! N - declare
	public const	IDATA	= 0x84;	! N - data
	public const	ICREF	= 0x85;	! L - code reference
	public const	IDREF	= 0x86;	! L - data reference
	public const	ISTR	= 0x87;	! K S - string
	public const	IPSTR	= 0x88;	! K S - packed string
	public const	IINIT	= 0x89;	! 3 N - init module
	public const	IHDR	= 0x0A;	! - procedure header
	public const	IEND	= 0x0B;	! - end proc ctx and return
	public const	ICCTX	= 0x0C;	! - create class context
	public const	IECTX	= 0x0D;	! - end class context
	public const	IPOP	= 0x0E;	! - pop to RR
	public const	IDUP	= 0x0F;	! - duplicate
	public const	ISWAP	= 0x10;	! - swap
	public const	ISTACK	= 0x91;	! N - adjust stack
	public const	ICLEAN	= 0x92;	! N - cleanup stack
	public const	INEG	= 0x13;	! - negate
	public const	ILNOT	= 0x14;	! - logical not
	public const	IBNOT	= 0x15;	! - binary not
	public const	INOP	= 0x16;	! - null operation
	public const	IINCG	= 0x97;	! L N - increment global
	public const	IINCI	= 0x98;	! N M - increment ivar
	public const	IINCL	= 0x99;	! N M - increment local
	public const	IMUL	= 0x1A;	! - multiply
	public const	IDIV	= 0x1B;	! - divide
	public const	IUMUL	= 0x1C;	! - unsigned multiply
	public const	IUDIV	= 0x1D;	! - unsigned divide
	public const	IMOD	= 0x1E;	! - modulo
	public const	IADD	= 0x1F;	! - add
	public const	ISUB	= 0x20;	! - subtract
	public const	IBAND	= 0x21;	! - binary and
	public const	IBOR	= 0x22;	! - binary or
	public const	IBXOR	= 0x23;	! - binary xor
	public const	IBSHL	= 0x24;	! - binary shift left
	public const	IBSHR	= 0x25;	! - binary shift right
	public const	IEQU	= 0x26;	! - equal
	public const	INEQU	= 0x27;	! - not equal
	public const	ILESS	= 0x28;	! - less
	public const	IGRTR	= 0x29;	! - greater
	public const	ILTEQ	= 0x2A;	! - less / equal
	public const	IGTEQ	= 0x2B;	! - greater / equal
	public const	IULESS	= 0x2C;	! - unsigned less
	public const	IUGRTR	= 0x2D;	! - unsigned greater
	public const	IULTEQ	= 0x2E;	! - unsigned less / equal
	public const	IUGTEQ	= 0x2F;	! - unsigned greater / equal
	public const	ILDG	= 0xB0;	! L - load global
	public const	ILDGV	= 0xB1;	! L - load global vector
	public const	ILDL	= 0xB2;	! N - load local
	public const	ILDLV	= 0xB3;	! N - local local vector
	public const	ILDI	= 0xB4;	! N - load instance
	public const	ILDIV	= 0xB5;	! N - load instance vector
	public const	ILDLAB	= 0xB6;	! L - load label
	public const	INUM	= 0xB7;	! N - load number
	public const	ISELF	= 0x38;	! - load instance pointer
	public const	IIND	= 0x39;	! - indirection
	public const	IINDB	= 0x3A;	! - bytewise indirection
	public const	IDEREF	= 0x3B;	! - dereference
	public const	IDREFB	= 0x3C;	! - dereference byte
	public const	ISAVG	= 0xBD;	! L - save global
	public const	ISAVL	= 0xBE;	! N - save local
	public const	ISAVI	= 0xBF;	! N - save instance
	public const	ISTORE	= 0x40;	! - save indirect
	public const	ISTORB	= 0x41;	! - save indirect byte
	public const	ICALL	= 0xC2;	! L - call procedure
	public const	ICALR	= 0x43;	! - call indirect procedure
	public const	ISYS	= 0xC4;	! N - execute RTS procedure N
	public const	IBRF	= 0xC5;	! L - branch on false
	public const	IBRT	= 0xC6;	! L - branch on true
	public const	INBRF	= 0xC7;	! L - non-destructive branch on false
	public const	INBRT	= 0xC8;	! L - non-destructive branch on true
	public const	IJUMP	= 0xC9;	! L - jump
	public const	IUNEXT	= 0xCA;	! L - upward next loop
	public const	IDNEXT	= 0xCB;	! L - downward next loop
	public const	IHALT	= 0xCC;	! N - halt program
	public const	IPUB	= 0xCD;	! L K S - public symbol
	public const	IEXT	= 0xCE;	! L K S - external symbol
	public const	ICALX	= 0xCF;	! E - call external procedure
	public const	ILINE	= 0xD0;	! N - debug: line number
	public const	IGSYM	= 0xD1;	! L K S - debug: global symbol
	public const	ILSYM	= 0xD2;	! N K S - debug: local symbol
	public const	IISYM	= 0xD3;	! N K S - debug: instance symbol
	public const	ICKSTK	= 0x54;	! - debug: check for stack overflow
	public const	IENDOFSET=0x55;
end

do
end
