/*
 *	TXX EXTENSIONS -- external procedure interface for TXX
 *	Copyright (C) 1997-2000 Nils M Holm. All rights reserved.
 *	See the file LICENSE for conditions of use.
 */

#define EXTERN extern

#ifdef MAIN
 #undef EXTERN
 #define EXTERN
#endif

#define uchar   unsigned char
#define ushort  unsigned short
#define uint    unsigned int
#define ulong   unsigned long

#ifdef unix
 #define HOST32 /* 32-bit host */
#endif  

#ifdef dos
 #include <dos.h>
 #ifdef __TURBOC__
  #define off_t	ulong
  /* OOPS! open() and friends translate LF<-->CRLF */
  #define creat(X,Y)	_creat((X),0)
  #define open		_open
  #define close		_close
  #define read		_read
 #endif
#endif

#ifdef HOST32
 #ifdef LIBRARY
  #define CELL	int
  #define UCELL	uint
  #define BPW	4
 #else
  #define CELL	short
  #define UCELL	ushort
  #define BPW	2
 #endif
#else
 #define CELL	short
 #define UCELL	ushort
 #define BPW	2
#endif

#ifndef LIBRARY
 #define ARG(C,N)	Stack[Sp+(C)-(N)]
 #define UARG(C,N)	Ustack[Sp+(C)-(N)]
 #define ARGP(C,N)	&Data[Ustack[Sp+(C)-(N)]]
#endif

#ifdef LIBRARY
 #define S0()		(__self)
 #define S1(x)		(__self,x)
 #define S2(x,y)	(__self,x,y)
 #define S3(x,y,z)	(__self,x,y,z)
 #define S4(x,y,z,a)	(__self,x,y,z,a)
#else
 #define S0()		()
 #define S1(x)		(x)
 #define S2(x,y)	(x,y)
 #define S3(x,y,z)	(x,y,z)
 #define S4(x,y,z,a)	(x,y,z,a)
#endif


EXTERN ushort	*Ustack;
EXTERN short	*Stack;
EXTERN ushort	Sp;
EXTERN uchar	*Data;
EXTERN short	Acc;
EXTERN char	**Argvec;
EXTERN int	Argcount;


#ifdef MAIN

void	X_bpw(), X_close(), X_cvalist(), X_getarg(), X_getenv(),
	X_memcomp(), X_memcopy(), X_memfill(), X_memscan(),
	X_newline(), X_open(), X_pack(), X_read(), X_remove(),
	X_rename(),
#ifdef SHL_SUPPORT
	X_shlopen(), X_shlsym(), X_shlcall(), X_shlclose(),
#endif
	X_seek(), X_sys(), X_unpack(), X_write();


void	(*Primitives[])() = {

	/*---TXX-PRIMITIVES-BEGIN---*/
	X_sys,
	X_bpw,
	X_memcopy,
	X_memcomp,
	X_memfill,
	X_memscan,
	X_pack,
	X_unpack,
	X_getarg,
	X_getenv,
	X_open,
	X_read,
	X_write,
	X_newline,
	X_seek,
	X_close,
	X_rename,
	X_remove,
	X_cvalist,
#ifdef SHL_SUPPORT
	X_shlopen,
	X_shlsym,
	X_shlcall,
	X_shlclose,
#endif
	/*---TXX-PRIMITIVES-END---*/

	0,
};

#endif	/* MAIN */
